/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DUDeFolder;

import java.awt.event.ActionEvent;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.border.TitledBorder;
import demodulation.FrameGenerator;
import java.awt.event.ActionListener;

/**
 *
 * @author matthijs
 */
public class ComPanel extends JPanel implements ActionListener{
        private final int samplerate = 38400;
 private final int MONO = 1;
 private AudioFormat format = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, samplerate, 16, MONO, 2, samplerate, true);//changed framesize to 1
 static private java.util.Vector<TargetDataLine> linelist = new java.util.Vector<TargetDataLine>();
 private static JProgressBar tuning_audiolevel;
 private JComboBox soundcardselect;
        static TargetDataLine tdl; 
        FrameGenerator frameGenerator = new FrameGenerator();

    ComPanel() {


  this.setBounds(0, 0, 310, 100);
                this.setBorder(new TitledBorder("Audio panel"));
  JProgressBar bar = new JProgressBar();
  bar.setMaximum(32768);
  this.add(bar);
  bar.setBounds(30, 30, 240, 15);

  tuning_audiolevel = bar;

  JComboBox soundcardbox = new JComboBox();
  Mixer.Info[] mixers = AudioSystem.getMixerInfo();
  for(int i = 0; i < mixers.length; i++)
  {
   try
   {
    TargetDataLine line = AudioSystem.getTargetDataLine(format, mixers[i]);
    soundcardbox.addItem(mixers[i].getName());
    linelist.add(line);
   }
   catch(Exception e){}
  }
  if(linelist.size() != 0)
  {
                    if(tdl == null)
                    tdl = linelist.elementAt(0);
                    soundcardbox.addActionListener(this); 
                }
  else
  {
   soundcardbox.setEnabled(false);
  }
  soundcardbox.setBounds(30, 60, 240, 20);
  this.add(soundcardbox);

  soundcardselect = soundcardbox;
                
                frameGenerator.start_audio(Main.frame, Main.dataFormat, tdl);
    }
private void soundcardselectActionPerformed(java.awt.event.ActionEvent evt)
 {
            tdl = linelist.elementAt(soundcardselect.getSelectedIndex());
            frameGenerator.start_audio(Main.frame, Main.dataFormat, tdl);
            StatusPanel.AppendStatus("Selected audio-in: " + "New audio-in slected");
 }

public static TargetDataLine getInput(){
    return tdl;
}

    public void actionPerformed(ActionEvent e) {
        soundcardselectActionPerformed(e);
    }

    public static void updatetuning(int level){
        tuning_audiolevel.setValue(level);
  if (level > 20000)
  {
   tuning_audiolevel.setForeground(new java.awt.Color(255, 0, 0));
  }
  else
  {
   tuning_audiolevel.setForeground(new java.awt.Color(0, 255, 0));
  }
    }
}
