/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DUDeFolder;

import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.border.TitledBorder;
import javax.swing.BoxLayout;

/**
 *
 * @author matthijs
 */
public class FreqPanel extends JPanel {

    private static JLabel tuning_lockstate, tuning_freqlabel;
    private static JSlider tuning_freqslider;

    public FreqPanel() {
        this.setBorder(new TitledBorder("Frequency"));
		this.setLayout(null);
        this.setBounds(310, 0, 620, 100);

        JSlider freqslider = new JSlider(900, 2300, 1600);
        freqslider.setMajorTickSpacing(200);
        freqslider.setMinorTickSpacing(50);
        freqslider.setPaintLabels(true);
        freqslider.setPaintTicks(true);
        freqslider.setBounds(50, 20, 280, 50);
        freqslider.setEnabled(false);
        this.add(freqslider);
        tuning_freqslider = freqslider;

		JPanel panel = new JPanel();
		panel.setBounds(340, 20, 200,50);
		panel.setLayout(null);

        JLabel synclabel = new JLabel("No sync");
        synclabel.setForeground(new Color(255, 0, 0));
        synclabel.setBounds(0, 20, 75, 20);
        synclabel.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
        panel.add(synclabel);

        tuning_lockstate = synclabel;

        JLabel freqlabel = new JLabel("1600");
        JLabel frequnitlabel = new JLabel(" Hz");
        freqlabel.setBounds(75, 20, 50, 20);
        freqlabel.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        frequnitlabel.setBounds(125, 20, 50, 20);        
		panel.add(frequnitlabel);
        panel.add(freqlabel);
		this.add(panel);

        tuning_freqlabel = freqlabel;
    }

    public static void updatetuning(int frequency, boolean lockstate)
	{
		tuning_freqlabel.setText("" + frequency);


		tuning_freqslider.setValue(frequency);

		if (lockstate)
		{
			tuning_lockstate.setEnabled(true);
			tuning_lockstate.setText("Sync");
			tuning_lockstate.setForeground(new java.awt.Color(0, 255, 0));
		}
		else
		{
			tuning_lockstate.setEnabled(false);
			tuning_lockstate.setText("No Sync");
		}
	}

}
