/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DUDeFolder;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import javax.swing.JOptionPane;

/**
 *
 * @author matthijs
 */


public class SelectSatellite {

    static String abbrev;
    int initial_carrier;
    int samplerate;
    int window;
    int clockfreq;
    double alpha;
    double alphaclock;
    String server_one;
    String server_two;
    static String name;
    static String version;

    public SelectSatellite() throws FileNotFoundException {
        String line;
        String[] line_split;
        String[] names = new String[1];int k = 0;
        String[] abbrev_temp = new String[1];
        String[] initial_carrier_temp = new String[1];
        String[] samplerate_temp = new String[1];
        String[] window_temp = new String[1];
        String[] clockfreq_temp = new String[1];
        String[] alpha_temp = new String[1];
        String[] alphaclock_temp = new String[1];
        String[] server_one_temp = new String[1];
        String[] server_two_temp = new String[1];

        BufferedReader reader = new BufferedReader(new FileReader("lib/names.txt"));
        
        // Creation of several arrays which are later matched with the chosen name.
        // These values are later used as information for the satellite specific values.
        try{
            while((line = reader.readLine()) != null) {
                
                line_split = line.split(",");
                
                names = expand(names, k+1); 
                abbrev_temp = expand(abbrev_temp, k+1);
                initial_carrier_temp = expand(initial_carrier_temp, k+1);
                samplerate_temp = expand(samplerate_temp, k+1);
                window_temp = expand(window_temp, k+1);
                clockfreq_temp = expand(clockfreq_temp, k+1);
                alpha_temp = expand(alpha_temp, k+1);
                alphaclock_temp = expand(alphaclock_temp, k+1);
                server_one_temp = expand(server_one_temp, k+1);
                server_two_temp = expand(server_two_temp, k+1);
                
                
                names[k] = line_split[0];
                abbrev_temp[k] = line_split[1];
                initial_carrier_temp[k] = line_split[2];
                samplerate_temp[k] = line_split[3];
                window_temp[k] = line_split[4];
                clockfreq_temp[k] = line_split[5];
                alpha_temp[k] = line_split[6];
                alphaclock_temp[k] = line_split[7];
                server_one_temp[k] = line_split[8];
                server_two_temp[k] = line_split[9];

                k++;

            }
        }catch(IOException e){
            StatusPanel.AppendStatus("waar is mijn file " + e.getStackTrace().toString());
        }
		//this gui will not be used for DC3
        //The optionpane  is initiated here, there is no need to use it now, cause the only satellite flying will be D3X 
		//and the program should search for itself which satellite is found.
        
/*            String s = (String) JOptionPane.showInputDialog(
                    null,
                    "Which satellite did you find",
                    "DUDe systems",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    names,
                    "DELFI C3");*/
String s = "Delfi n3Xt";		//when more satellites needs to be seen this can be changed in whatever the method is to receive the satellites name
if(s != null){

//If the name in the names array is equal of the chosen name the possition of that name is 
//matched to the other arrays to extract the corrosponding information

for (int i =0; i<k; i++){
    if(s.equals(names[i])){

        name = names[i];
      /*      
    String abbrev;
    int initial_carrier;
    int samplerate;
    int window;
    int slockfreq;
    double alpha;
    double alphaclock;
    String server_one;
    String server_two; */

        abbrev = abbrev_temp[i]; System.out.println(abbrev);
        initial_carrier = Integer.parseInt(initial_carrier_temp[i]);
        samplerate = Integer.parseInt(samplerate_temp[i]);
        window = Integer.parseInt(window_temp[i]);
        clockfreq = Integer.parseInt(clockfreq_temp[i]);
        alpha = Double.parseDouble(alpha_temp[i]);
        alphaclock = Double.parseDouble(alphaclock_temp[i]);
        server_one = server_one_temp[i];
        server_two = server_two_temp[i];
       
        }
}
}else {System.exit(0);}
}
            
    
    /* method is needed to expand the array for the erlier retrieving of information*/
private static String[] expand(String[] array, int size) {
        String[] temp = new String[size];
    System.arraycopy(array, 0, temp, 0, array.length);
    for(int j = array.length; j < size; j++)
        temp[j] = "";
    return temp;
    }

 /*
  * Dit soort methodes zijn nodig om de waardes netjes naar boven te kunnen halen.
  * gelijk maken met het schrijven van de inhoud van de namenlijst
  */

public static String getName(){
        return name;
    }

public static String getAbbrev(){
    return abbrev;
}

public int getInitialCarrier(){
    return initial_carrier;
}

public int getSamplerate(){
    return samplerate;
}

public int getWindow(){
    return window;
}

public int getClockFreq(){
    return clockfreq;
}

public double getAlpha(){
    return alpha;
}

public double getAlphaClock(){
    return alphaclock;
}

public String getServerOne(){
    return server_one;
}

public String getServerTwo(){
    return server_two;
}

public static String getVersion(){
    return version;
}


     }
