package hashmap;

import java.text.DecimalFormat;
import javax.swing.JLabel;

/**
 *
 * @author Matthijs Kuiper
 */
public class DataJLabel extends JLabel{
    String name;
    String prefix;
    String suffix;
    Double currentdata = null;

    public DataJLabel(String name_in, String prefix_in, String suffix_in){
        super();
        
        //linking the initial text to the Label;
        this.setAlignmentX(CENTER_ALIGNMENT);
        this.name = name_in;
        this.prefix = prefix_in;
        this.suffix = suffix_in;
        this.setText(prefix + name + suffix);
    }

    public void Update(DataFrame data){ 
       DecimalFormat df = new DecimalFormat("#.##");
        currentdata = data.get(name);
        String currentdatatemp;
        if(currentdata != null){
            currentdatatemp = (df.format(currentdata));
            this.setText(prefix + "  " + currentdatatemp + "  " + suffix);
        }else
            this.setText(prefix + "  N/A ");
        
    }
}
